
#ifndef USER_HH
#define USER_HH

#include "AppControl.hh"
#include "umlrtcapsule.hh"
#include "umlrtcapsuleclass.hh"
#include "umlrtmessage.hh"
#include "umlrttimerid.hh"
#include "umlrttimerprotocol.hh"
struct UMLRTCommsPort;
struct UMLRTSlot;

#include <iostream>
#include <iomanip>
#include <cstdlib>

class Capsule_User : public UMLRTCapsule
{
public:
    Capsule_User( const UMLRTCapsuleClass * cd, UMLRTSlot * st, const UMLRTCommsPort * * border, const UMLRTCommsPort * * internal, bool isStat );
protected:
    AppControl::Conj computerPort;
public:
    enum BorderPortId
    {
        borderport_computerPort,
        borderport_timer
    };
protected:
    UMLRTTimerProtocol_baserole timer;
public:
    enum PartId
    {
    };
    enum PortId
    {
        port_computerPort,
        port_timer
    };
    virtual void bindPort( bool isBorder, int portId, int index );
    virtual void unbindPort( bool isBorder, int portId, int index );
protected:
    int numSec;
    UMLRTTimerId timerID;
    bool status;
public:
    virtual void inject( const UMLRTMessage & message );
    virtual void initialize( const UMLRTMessage & message );
    const char * getCurrentStateString() const;
private:
    enum State
    {
        Alive,
        FAILED,
        TestDone,
        Waiting4DocPrint,
        Waiting4DocSave,
        SPECIAL_INTERNAL_STATE_UNVISITED
    };
    const char * stateNames[6];
    State currentState;
    void entryaction_____Alive( const UMLRTMessage * msg );
    void entryaction_____FAILED( const UMLRTMessage * msg );
    void entryaction_____TestDone( const UMLRTMessage * msg );
    void entryaction_____Waiting4DocPrint( const UMLRTMessage * msg );
    void entryaction_____Waiting4DocSave( const UMLRTMessage * msg );
    void exitaction_____Alive( const UMLRTMessage * msg );
    void exitaction_____Waiting4DocPrint( const UMLRTMessage * msg );
    void exitaction_____Waiting4DocSave( const UMLRTMessage * msg );
    void transitionaction_____TransitionAction6( const UMLRTMessage * msg );
    void transitionaction_____TransitionAction7( const UMLRTMessage * msg );
    void transitionaction_____TransitionAction8( const UMLRTMessage * msg );
    void transitionaction_____TransitionAction9( const UMLRTMessage * msg );
    void transitionaction_____initTimerFail( const UMLRTMessage * msg );
    void transitionaction_____initTimerSet( const UMLRTMessage * msg );
    void transitionaction_____initialize( const UMLRTMessage * msg );
    void transitionaction_____isFalsePrintDoc( const UMLRTMessage * msg );
    void transitionaction_____isTrueDone( const UMLRTMessage * msg );
    void transitionaction_____onTimeout1( const UMLRTMessage * msg );
    void transitionaction_____onTimeout2( const UMLRTMessage * msg );
    bool action_____TransitionAction6__saveOK( const UMLRTMessage * msg );
    bool action_____TransitionAction7__printSet( const UMLRTMessage * msg );
    bool action_____TransitionAction8__saveFail( const UMLRTMessage * msg );
    bool action_____TransitionAction9__printFail( const UMLRTMessage * msg );
    bool action_____initTimerFail__invalidTimer( const UMLRTMessage * msg );
    bool action_____initTimerSet__timerValid( const UMLRTMessage * msg );
    bool action_____isFalsePrintDoc__isFalse( const UMLRTMessage * msg );
    bool action_____isTrueDone__isTrue( const UMLRTMessage * msg );
    void actionchain_____TransitionAction10( const UMLRTMessage * msg );
    void actionchain_____TransitionAction6( const UMLRTMessage * msg );
    void actionchain_____TransitionAction7( const UMLRTMessage * msg );
    void actionchain_____TransitionAction8( const UMLRTMessage * msg );
    void actionchain_____TransitionAction9( const UMLRTMessage * msg );
    void actionchain_____initTimerFail( const UMLRTMessage * msg );
    void actionchain_____initTimerSet( const UMLRTMessage * msg );
    void actionchain_____initialize( const UMLRTMessage * msg );
    void actionchain_____isFalsePrintDoc( const UMLRTMessage * msg );
    void actionchain_____isTrueDone( const UMLRTMessage * msg );
    void actionchain_____onTimeout1( const UMLRTMessage * msg );
    void actionchain_____onTimeout2( const UMLRTMessage * msg );
    void actionchain_____onTimeout3( const UMLRTMessage * msg );
    State choice_____TesterChoice( const UMLRTMessage * msg );
    State choice_____tid1_( const UMLRTMessage * msg );
    State choice_____tid2_( const UMLRTMessage * msg );
    State choice_____tid3_( const UMLRTMessage * msg );
    State state_____Alive( const UMLRTMessage * msg );
    State state_____FAILED( const UMLRTMessage * msg );
    State state_____TestDone( const UMLRTMessage * msg );
    State state_____Waiting4DocPrint( const UMLRTMessage * msg );
    State state_____Waiting4DocSave( const UMLRTMessage * msg );
};
extern const UMLRTCapsuleClass User;

#endif

