
#ifndef SERVER1_HH
#define SERVER1_HH

#include "Server.hh"
#include "Service.hh"
#include "umlrtcapsuleclass.hh"
#include "umlrtlogprotocol.hh"
#include "umlrtmessage.hh"
struct UMLRTCommsPort;
struct UMLRTSlot;

class Capsule_Server1 : public Capsule_Server
{
public:
    Capsule_Server1( const UMLRTCapsuleClass * cd, UMLRTSlot * st, const UMLRTCommsPort * * border, const UMLRTCommsPort * * internal, bool isStat );
protected:
    UMLRTLogProtocol_baserole log;
    Service::Base service;
public:
    enum InternalPortId
    {
        internalport_service,
        internalport_log
    };
    enum PartId
    {
    };
    enum PortId
    {
        port_log,
        port_service
    };
    virtual void bindPort( bool isBorder, int portId, int index );
    virtual void unbindPort( bool isBorder, int portId, int index );
    virtual void inject( const UMLRTMessage & message );
    virtual void initialize( const UMLRTMessage & message );
    const char * getCurrentStateString() const;
private:
    enum State
    {
        WaitingForRequests,
        SPECIAL_INTERNAL_STATE_UNVISITED
    };
    const char * stateNames[2];
    State currentState;
    void entryaction_____WaitingForRequests( const UMLRTMessage * msg );
    void exitaction_____WaitingForRequests( const UMLRTMessage * msg );
    void transitionaction_____TransitionAction1( const UMLRTMessage * msg );
    void actionchain_____Initial( const UMLRTMessage * msg );
    void actionchain_____TransitionAction1( const UMLRTMessage * msg );
    State state_____WaitingForRequests( const UMLRTMessage * msg );
};
extern const UMLRTCapsuleClass Server1;

#endif

