
#ifndef TOP_HH
#define TOP_HH

#include "umlrtcapsule.hh"
#include "umlrtcapsuleclass.hh"
#include "umlrtframeprotocol.hh"
#include "umlrtlogprotocol.hh"
#include "umlrtmessage.hh"
struct UMLRTCapsulePart;
struct UMLRTCommsPort;
struct UMLRTSlot;

#include "Server1.hh"

class Capsule_Top : public UMLRTCapsule
{
public:
    Capsule_Top( const UMLRTCapsuleClass * cd, UMLRTSlot * st, const UMLRTCommsPort * * border, const UMLRTCommsPort * * internal, bool isStat );
protected:
    UMLRTFrameProtocol_baserole frame;
public:
    enum InternalPortId
    {
        internalport_frame,
        internalport_log
    };
protected:
    UMLRTLogProtocol_baserole log;
public:
    enum PartId
    {
        part_client,
        part_server
    };
protected:
    const UMLRTCapsulePart * const client;
    const UMLRTCapsulePart * const server;
public:
    enum PortId
    {
        port_frame,
        port_log
    };
    virtual void bindPort( bool isBorder, int portId, int index );
    virtual void unbindPort( bool isBorder, int portId, int index );
    virtual void inject( const UMLRTMessage & message );
    virtual void initialize( const UMLRTMessage & message );
    const char * getCurrentStateString() const;
private:
    enum State
    {
        Working,
        SPECIAL_INTERNAL_STATE_UNVISITED
    };
    const char * stateNames[2];
    State currentState;
    void entryaction_____Working( const UMLRTMessage * msg );
    void actionchain_____Initial( const UMLRTMessage * msg );
    State state_____Working( const UMLRTMessage * msg );
};
extern const UMLRTCapsuleClass Top;

#endif

